<template>
    <!-- Name, Transfer Button, End Conversation Button -->
    <div class="chatbox-header items-center">
        <div class="row q-pl-md items-center fixed-height">
            <!-- Name -->
            <div class="col-5 col-md-5 row items-center">
                <span
                    v-if="
                        selectedUserID &&
                        selectedConversationID &&
                        state.belongToOwner &&
                        state.isClosedChat &&
                        componentStatus
                    "
                    class="
                        helvetica-neue-medium
                        font-16
                        text-white
                        items-center
                        conversation-header
                        q-pr-xs
                    "
                >
                    {{ getUserName(selectedConversationID) }}
                </span>
                <div v-if="$q.platform.is.desktop" class="row">
                    <div
                        v-if="
                            selectedUserID &&
                            selectedConversationID &&
                            state.belongToOwner &&
                            state.isClosedChat &&
                            componentStatus
                        "
                    >
                        <q-icon
                            class="chat-label"
                            v-for="label in state.labels"
                            :key="label.id"
                            :style="{
                                backgroundColor: label.color
                            }"
                            :name="label.icon"
                            color="white"
                            size="xs"
                        ></q-icon>
                    </div>
                    <div>
                        <q-btn
                            v-if="
                                selectedUserID &&
                                selectedConversationID &&
                                state.belongToOwner &&
                                state.isClosedChat &&
                                componentStatus
                            "
                            flat
                            dense
                            size="md"
                            color="white"
                            icon="add_circle"
                            @click="assignLabel()"
                        />
                    </div>
                </div>
            </div>
            <div v-if="$q.platform.is.desktop" class="col-4 col-md-3">
                <div
                    v-if="
                        selectedUserID &&
                        selectedConversationID &&
                        state.belongToOwner &&
                        state.isClosedChat &&
                        componentStatus
                    "
                >
                    <q-select
                        class="issueType-text"
                        v-model="state.issueTypeValue"
                        :options="state.setIssueType"
                        option-value="id"
                        option-label="name"
                        borderless
                        dense
                        @update:model-value="updateConversationIssueType"
                    ></q-select>
                </div>
            </div>

            <!-- Conversation Option Menu -->
            <div
                v-if="$q.platform.is.desktop"
                class="col-3 col-md-4 row justify-end q-pr-md"
            >
                <div
                    v-if="
                        selectedUserID &&
                        selectedConversationID &&
                        state.belongToOwner &&
                        state.isClosedChat &&
                        componentStatus
                    "
                >
                    <q-btn
                        flat
                        dense
                        size="lg"
                        icon="expand_more
                    "
                    >
                        <q-menu
                            class="conversation-menu"
                            anchor="bottom left"
                            self="top middle"
                            auto-close
                        >
                            <q-item
                                clickable
                                @click="
                                    !conversationTransfer
                                        ? openSelectMember()
                                        : cancelTransfer()
                                "
                            >
                                <q-item-section
                                    class="helvetica-neue-medium font-14"
                                >
                                    {{
                                        !conversationTransfer
                                            ? 'Transfer'
                                            : 'Cancel'
                                    }}
                                </q-item-section>
                            </q-item>

                            <div v-if="!conversationTransfer">
                                <q-separator color="white" />

                                <!-- Appointment -->
                                <q-item
                                    clickable
                                    @click="openCreateAppointmentForm()"
                                >
                                    <q-item-section
                                        class="helvetica-neue-medium font-14"
                                    >
                                        Appointment
                                    </q-item-section>
                                </q-item>
                                <q-separator color="white" />

                                <!-- Search -->
                                <q-item clickable @click="openBox">
                                    <q-item-section
                                        class="helvetica-neue-medium font-14"
                                    >
                                        Search
                                    </q-item-section>
                                </q-item>
                                <q-separator color="white" />

                                <!-- End Chat -->
                                <q-item
                                    clickable
                                    @click="endChat(selectedConversationID)"
                                >
                                    <q-item-section
                                        class="helvetica-neue-medium font-14"
                                    >
                                        End Chat
                                    </q-item-section>
                                </q-item>
                            </div>
                        </q-menu>
                    </q-btn>
                </div>
            </div>

            <div
                v-if="$q.platform.is.mobile"
                class="col-7 row justify-end q-pr-sm"
            >
                <div
                    v-if="
                        selectedUserID &&
                        selectedConversationID &&
                        state.belongToOwner &&
                        state.isClosedChat &&
                        componentStatus
                    "
                >
                    <q-btn
                        flat
                        dense
                        size="lg"
                        icon="expand_more
                    "
                    >
                        <q-menu
                            class="conversation-menu"
                            anchor="bottom left"
                            self="top middle"
                            auto-close
                        >
                            <q-item
                                clickable
                                @click="
                                    !conversationTransfer
                                        ? openSelectMember()
                                        : cancelTransfer()
                                "
                            >
                                <q-item-section
                                    class="helvetica-neue-medium font-14"
                                >
                                    {{
                                        !conversationTransfer
                                            ? 'Transfer'
                                            : 'Cancel'
                                    }}
                                </q-item-section>
                            </q-item>

                            <div v-if="!conversationTransfer">
                                <q-separator color="white" />

                                <!-- Appointment -->
                                <q-item
                                    clickable
                                    @click="openCreateAppointmentForm()"
                                >
                                    <q-item-section
                                        class="helvetica-neue-medium font-14"
                                    >
                                        Appointment
                                    </q-item-section>
                                </q-item>
                                <q-separator color="white" />

                                <!-- Request -->
                                <q-item clickable>
                                    <q-item-section
                                        class="helvetica-neue-medium font-14"
                                    >
                                        Request
                                    </q-item-section>
                                </q-item>
                                <q-separator color="white" />

                                <!-- Search -->
                                <q-item clickable @click="openBox">
                                    <q-item-section
                                        class="helvetica-neue-medium font-14"
                                    >
                                        Search
                                    </q-item-section>
                                </q-item>
                                <q-separator color="white" />

                                <!-- End Chat -->
                                <q-item
                                    clickable
                                    @click="endChat(selectedConversationID)"
                                >
                                    <q-item-section
                                        class="helvetica-neue-medium font-14"
                                    >
                                        End Chat
                                    </q-item-section>
                                </q-item>
                            </div>
                        </q-menu>
                    </q-btn>
                </div>
            </div>
        </div>

        <!-- Mobile Labels -->
        <div v-if="$q.platform.is.mobile">
            <div class="row items-center col-12 q-pb-md">
                <div class="q-pl-sm">
                    <div
                        v-if="
                            selectedUserID &&
                            selectedConversationID &&
                            state.belongToOwner &&
                            state.isClosedChat &&
                            componentStatus
                        "
                    >
                        <q-icon
                            class="chat-label"
                            v-for="label in state.labels"
                            :key="label.id"
                            :style="{
                                backgroundColor: label.color
                            }"
                            :name="label.icon"
                            color="white"
                            size="xs"
                        ></q-icon>
                    </div>
                </div>
                <div>
                    <q-btn
                        v-if="
                            selectedUserID &&
                            selectedConversationID &&
                            state.belongToOwner &&
                            state.isClosedChat &&
                            componentStatus
                        "
                        flat
                        dense
                        size="md"
                        color="white"
                        icon="add_circle"
                        @click="assignLabel()"
                    />
                </div>
                <q-select
                    v-if="
                        selectedUserID &&
                        selectedConversationID &&
                        state.belongToOwner &&
                        state.isClosedChat &&
                        componentStatus
                    "
                    class="issueType-text"
                    v-model="state.issueTypeValue"
                    :options="state.setIssueType"
                    option-value="id"
                    option-label="name"
                    borderless
                    dense
                    @update:model-value="updateConversationIssueType"
                ></q-select>
            </div>
        </div>
    </div>

    <!-- Chat Details -->
    <message-list :loading="state.loading" />

    <footer-section
        v-if="
            selectedUserID &&
            selectedConversationID &&
            state.belongToOwner &&
            state.isClosedChat &&
            componentStatus
        "
        @submit="submit"
        @filesSelected="onFilesSelected"
    />

    <!-- User Selection Modal (Transfer to XXX ) -->
    <user-selection
        v-model="state.confirm"
        :convId="selectedConversationID"
        :tab="tab"
        @update-confirm="updateConfirm"
        :conversationOwner="state.conversationOwner"
    />

    <!-- Assign label to conversation -->
    <label-selection
        v-model="state.assign"
        :convId="selectedConversationID"
        :tab="tab"
        @update-assign="updateAssign"
    />

    <!-- Create Appointment Form -->
    <q-dialog v-model="state.appointmentDialog" persistent>
        <appointment-dialog :conversationList="true" />
    </q-dialog>
</template>

<script lang="ts">
import {
    defineComponent,
    ref,
    computed,
    reactive,
    onMounted,
    watch
} from 'vue';
import { mapGetters } from 'vuex';
import { useQuasar } from 'quasar';
import { useRouter } from 'vue-router';
import MessageList from 'src/components/chats/MessageList.vue';
import { useStore } from 'src/store';
import { Message } from 'src/services/models/Message';
import UserSelection from 'src/components/modals/UserSelection.vue';
import DeleteMessageDialog from 'src/components/modals/DeleteMessageDialog.vue';
import FooterSection from 'src/components/chats/Footer.vue';
import LabelSelection from 'src/components/modals/LabelSelection.vue';
import AlertCustomDialog from 'src/components/modals/AlertCustomDialog.vue';
import { ConversationStatus } from 'src/services/enums/ConversationStatus';
import { useI18n } from 'vue-i18n';
import AppointmentDialog from 'src/components/modals/AppointmentDialog.vue';

export default defineComponent({
    name: 'ConversationList',
    computed: {
        ...mapGetters({
            selectedConversationID: 'conversation/getSelectedConversationID',
            selectedUserID: 'conversation/getSelectedUserID',
            componentStatus: 'conversation/getComponent'
        })
    },
    props: {
        tab: {
            type: String,
            required: true
        }
    },
    emits: [
        'submit',
        'textChanged',
        'filesSelected',
        'updateList',
        'openSearchBox'
    ],
    components: {
        MessageList,
        UserSelection,
        FooterSection,
        LabelSelection,
        AppointmentDialog
    },
    setup(props, { emit }) {
        const { t } = useI18n({ useScope: 'global' });
        const $q = useQuasar();
        const router = useRouter();
        const store = useStore();
        const conversationState = store.state.conversation;
        let conversationTransfer = ref(false);
        let conversationTransferDetails: any = [];

        const selectedMessages = computed(
            (): Record<string, Message> => store.state.chat.selectedMessages
        );

        const issueList = computed(() => {
            return store.state.issueType.issueTypes;
        });

        const selectedBranchId = computed(() => {
            return store.state.branch.branch.id;
        });

        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });

        const selectedConversationId = computed(() => {
            return store.state.conversation.selectedConversationID;
        });

        let state = reactive({
            confirm: ref(false),
            loading: ref(false),
            assign: ref(false),
            belongToOwner: ref(false),
            conversationOwner: ref(''),
            isClosedChat: ref(true),
            permissions: computed(() => {
                return store.state.role.permissions;
            }),
            issueTypeValue: '' as any,
            setIssueType: [] as any,
            appointmentDialog: ref(false),
            labels: [] as any
        });

        // Methods
        const getUserName = (conversationID: string) => {
            const conversation = conversationState.conversationsList.find(
                (conversation) => conversation.id === conversationID
            );
            setConversationOwner(conversation);
            return conversation?.user.name;
        };

        const setConversationOwner = (conversation: any) => {
            state.conversationOwner = conversation?.agent.id ?? '';
        };

        const hasBeenTransfer = () => {
            const conversation = conversationState.conversationsList.find(
                (conversation) =>
                    conversation.id === conversationState.selectedConversationID
            );
            if (conversation?.transfer) {
                conversationTransferDetails = conversation?.transfer;
                conversationTransfer.value = true;
            } else {
                conversationTransfer.value = false;
            }
        };

        const endChat = (conversationID: string) => {
            $q.dialog({
                component: AlertCustomDialog,
                componentProps: {
                    title: t('alerts.endChatSession'),
                    message: t('alerts.endChatConfirmation')
                }
            }).onOk(() => {
                store.dispatch('conversation/endConversation', conversationID);
                store.dispatch('chat/unselectConversation');
                store.dispatch('message/reset');
                store.dispatch('note/clearNote');
                store.dispatch(
                    'conversation/removeConvoFromList',
                    conversationID
                );
                store.dispatch('conversation/clearSelectedConversation');
                store.dispatch('conversation/clearSelectedConversationID');
                router.push('/helpdesk');
            });
        };

        const openSelectMember = () => {
            state.confirm = true;
        };

        const updateConfirm = (value: boolean) => {
            state.confirm = value;
            conversationTransfer.value = true;
        };

        const updateAssign = (value: boolean) => {
            state.assign = value;
        };

        const cancelTransfer = async () => {
            if (state.permissions?.conversation?.transferCancel == true) {
                hasBeenTransfer();
                await store.dispatch(
                    'conversation/cancelTransferConversation',
                    {
                        transferId: conversationTransferDetails?.id
                    }
                );
                conversationTransfer.value = false;
            }
        };

        const onFavourite = () => {
            const messageIds = Object.keys(selectedMessages.value);
            store.dispatch('message/favouriteFlag', { messageIds, value: 1 });
            store.dispatch('chat/setIsSelectMultiple', false);
        };

        const onUnfavourite = () => {
            const messageIds = Object.keys(selectedMessages.value);
            store.dispatch('message/favouriteFlag', { messageIds, value: 0 });
            store.dispatch('chat/setIsSelectMultiple', false);
        };

        const onDelete = () => {
            const messageIds = Object.keys(selectedMessages.value);
            $q.dialog({
                component: DeleteMessageDialog,
                componentProps: {
                    messageIds
                }
            }).onOk(() => {
                store.dispatch('chat/setIsSelectMultiple', false);
            });
        };

        const submit = (body: any) => {
            emit('submit', body);
        };

        const onFilesSelected = (value: any) => {
            emit('filesSelected', value);
        };

        const updateConversationList = (
            conversationID: any,
            issueType: any
        ) => {
            emit('updateList', conversationID, issueType);
        };

        const openBox = () => {
            emit('openSearchBox');
        };

        const assignLabel = () => {
            state.assign = true;
        };

        const checkBelongToOwner = () => {
            const currentUser = store.state.user.user;

            if (
                currentUser &&
                store.state.conversation.selectedConversation?.lastAgent?.id
            ) {
                state.belongToOwner =
                    currentUser.id ==
                    store.state.conversation.selectedConversation?.lastAgent
                        ?.id;
            } else if (
                currentUser &&
                store.state.conversation.selectedConversation?.agent?.id
            ) {
                state.belongToOwner =
                    currentUser.id ==
                    store.state.conversation.selectedConversation?.agent?.id;
            }
        };

        const checkConversationStatus = () => {
            const status =
                store.state.conversation.selectedConversation?.status || null;

            if (status == ConversationStatus.CLOSED || status == 'Closed') {
                state.isClosedChat = false;
            } else {
                state.isClosedChat = true;
            }
        };

        const getIssueTypesList = () => {
            issueList.value.forEach((element: any) => {
                let issueTypes = {
                    id: element.id,
                    name: element.name
                };
                state.setIssueType.push(issueTypes);
            });
        };

        const getIssueTypeByBusinessID = async () => {
            const result = await store.dispatch(
                'issueType/getIssueTypeByBusinessID',
                {
                    businessId: selectedBusinessId.value,
                    isHiddenIncluded: true
                }
            );

            if (result.issueTypes.length > 0) {
                result.issueTypes.forEach((element: any) => {
                    if (
                        element.id ==
                        conversationState.selectedConversation?.issueType.id
                    ) {
                        state.issueTypeValue = element.name;
                    }
                });
            }

            getIssueTypesList();
        };

        const updateConversationIssueType = async () => {
            await store.dispatch('conversation/setChangeStatus', true);
            await store.dispatch('conversation/updateConversationIssueType', {
                conversationId: store.state.conversation.selectedConversationID,
                issueTypeId: state.issueTypeValue.id
            });

            setTimeout(() => {
                getConversation();
            }, 300);

            updateConversationList(
                selectedConversationId.value,
                state.issueTypeValue
            );
            changeStatus();
        };

        const getConversation = async () => {
            await store.dispatch('conversation/getConversation', {
                branchId: selectedBranchId.value,
                businessId: selectedBusinessId.value,
                isDownward: 0
            });
        };

        const changeStatus = () => {
            setTimeout(() => {
                store.dispatch('conversation/setChangeStatus', false);
            }, 2000);
        };

        const openCreateAppointmentForm = () => {
            state.appointmentDialog = true;
        };

        const getLabel = () => {
            state.labels = conversationState.selectedConversation?.labels;
        };

        // Watch
        store.watch(
            () => conversationState.selectedConversationID,
            () => {
                checkConversationStatus();
                checkBelongToOwner();
                hasBeenTransfer();
                state.setIssueType = [];
                state.issueTypeValue = '';
                state.labels = [];
                getLabel();
                setTimeout(() => {
                    getIssueTypeByBusinessID();
                }, 300);
            }
        );

        store.watch(
            () => conversationState.selectedConversation?.labels,
            () => {
                state.labels = [];
                getLabel();
            }
        );

        watch(selectedBusinessId, () => {
            state.setIssueType = [];
            state.issueTypeValue = '';
            setTimeout(() => {
                getIssueTypeByBusinessID();
            }, 500);
        });

        onMounted(getLabel);
        onMounted(getIssueTypeByBusinessID);
        onMounted(hasBeenTransfer);
        onMounted(checkBelongToOwner);

        return {
            state,
            conversationTransfer,
            getUserName,
            endChat,
            openSelectMember,
            updateConfirm,
            cancelTransfer,
            onFavourite,
            onUnfavourite,
            onDelete,
            submit,
            onFilesSelected,
            assignLabel,
            updateAssign,
            updateConversationIssueType,
            issueList,
            openBox,
            openCreateAppointmentForm
        };
    }
});
</script>
